#!/bin/bash
##
#/etc/label/appLABEL format ->  path:label
#
conf=/etc/label/appLABEL
label="SmackProcessLabel"
if [ ! -s $conf ]; then
   echo "The file $conf is empty."
   exit
fi
#
#support service name.   ssh:8f002401010731302f2e3b3a393845501011

while read line
do
    #filepath=`echo "$line" | awk -F: '{print $1}'`
    #filelabel=`echo "$line" | awk -F: '{print $2}'`
    filepath=${line%:*}.service
    filelabel=${line#*:}
    echo "path:/lib/systemd/system/[$filepath] label:[$filelabel]"
    if [ -s /lib/systemd/system/$filepath ]; then
	havelabel=`cat /lib/systemd/system/$filepath | grep $label | awk -F= '{print $2}'`
	if [ "X$havelabel" = "X" ]; then
	    echo "No $lable yet."
	    sed -i '/^\[Service]/a\SmackProcessLabel='$filelabel /lib/systemd/system/$filepath
	    havelabel=`cat /lib/systemd/system/$filepath | grep $label | awk -F= '{print $2}'`
	    if [ "X$havelabel" != "X" ]; then
		echo "$havelabel ProcessLabel added!"
	    fi
	else
	    echo "The $conf file has ProcessLabel [$havelabel]"
	    continue
	fi
    fi

done < $conf
#support service path.  /lib/systemd/system/ssh.service:8f002401010731302f2e3b3a393845501011
while read line
do
    #filepath=`echo "$line" | awk -F: '{print $1}'`
    #filelabel=`echo "$line" | awk -F: '{print $2}'`
    filepath=${line%:*}
    filelabel=${line#*:}
    echo "path:[$filepath] label:[$filelabel]"
    if [ -s $filepath ]; then
	havelabel=`cat $filepath | grep $label | awk -F= '{print $2}'`
	if [ "X$havelabel" = "X" ]; then
	    echo "No $lable yet."
	    sed -i '/^\[Service]/a\SmackProcessLabel='$filelabel $filepath
	    havelabel=`cat $filepath | grep $label | awk -F= '{print $2}'`
	    if [ "X$havelabel" != "X" ]; then
		echo "$havelabel ProcessLabel added!"
	    fi
	else
	    echo "The $conf file has ProcessLabel [$havelabel]"
	    continue
	fi
    fi

done < $conf



systemctl daemon-reload

